from django.db import models
from django.contrib import admin

class UserConfirmation(models.Model):
	user = models.CharField(max_length=30)
	uuid = models.CharField(max_length=32)
	expire = models.DateTimeField()
	
	def __unicode__(self):
		return self.user

class Sheet(models.Model):
	title = models.CharField(max_length=200)
	create_date = models.DateTimeField()
	mod_date = models.DateTimeField()
	owner = models.CharField(max_length=30)
	permission = models.IntegerField()
	
	def __unicode__(self):
		return self.title

class Question(models.Model):
	sheet = models.ForeignKey(Sheet)
	order = models.IntegerField()
	question = models.CharField(max_length=400)
	ans_format = models.IntegerField()
	ans_property = models.CharField(max_length=400)
	attachment = models.CharField(max_length=36)
	
	def __unicode__(self):
		return self.question

class Survey(models.Model):
	title = models.CharField(max_length=200)
	create_date = models.DateTimeField()
	mod_date = models.DateTimeField()
	pub_date = models.DateTimeField(null=True)
	expire = models.DateTimeField(null=True)
	sheet = models.ForeignKey(Sheet)
	owner = models.CharField(max_length=30)
	permission = models.IntegerField()
	status = models.IntegerField()
	
	def __unicode__(self):
		return self.title

admin.site.register(Sheet)
admin.site.register(Question)
admin.site.register(Survey)
