function labelformatter(total)
{
	return function(format, val) {
		if(total == 0)
		{
			return ""
		}
		return $.jqplot.sprintf(format, val / total * 100, val)
	};
}

var bar_chart = function(total, fontsize) {
	return {
	grid: {
		borderWidth: 1,
		shadow: false,
		background: "#fff",
	},
	axes: {
		yaxis: {
			renderer: $.jqplot.CategoryAxisRenderer,
			tickOptions: {
				showGridline: false,
				mark: false,
				fontSize: fontsize,
			}
		},
		xaxis: {
			tickOptions: {
				show: false,
			}
		}
	},
	seriesDefaults: {
		renderer: jQuery.jqplot.BarRenderer,
		rendererOptions: {
			barDirection: "horizontal",
			highlightColors: "#48c"
		},
		pointLabels: {
			show: true,
			location: "w",
			escapeHTML: false,
			formatString: "<div class=\"chartlabel\" style=\"font-size: " + fontsize + "\">&nbsp;%.1f%%&nbsp;</div>",
			formatter: labelformatter(total),
		},
		shadow: false,
	},
	};
};

var bar_chart_count = function(fontsize) {
	return {
	grid: {
		borderWidth: 1,
		shadow: false,
		background: "#fff",
	},
	axes: {
		yaxis: {
			renderer: $.jqplot.CategoryAxisRenderer,
			tickOptions: {
				showGridline: false,
				mark: false,
				fontSize: fontsize,
			}
		},
		xaxis: {
			tickOptions: {
				show: false,
			}
		}
	},
	seriesDefaults: {
		renderer: jQuery.jqplot.BarRenderer,
		rendererOptions: {
			barDirection: "horizontal",
			highlightColors: "#48c"
		},
		pointLabels: {
			show: true,
			location: "w",
			escapeHTML: false,
			formatString: "<div class=\"chartlabel\" style=\"font-size: " + fontsize + "\">&nbsp;%s&nbsp;</div>",
		},
		shadow: false,
	},
	};
};
