function get_item_tag(id, question, format, property, attacheduuid)
{
	if(format == 0)
	{
		format_text = gettext("Text");
		propertyname = gettext("Maximum characters:");
	}
	else if(format == 1)
	{
		format_text = gettext("Ranking");
		propertyname = gettext("Maximum value:");
	}
	else if(format == 2)
	{
		format_text = gettext("Choices (single selection)");
		propertyname = gettext("Choices:");
	}
	else if(format == 3)
	{
		format_text = gettext("Choices (multiple selection)");
		propertyname = gettext("Choices:");
	}
	else if(format == 4)
	{
		format_text = gettext("Stream");
		propertyname = gettext("Maximum characters:");
	}
	if(attacheduuid == "")
	{
		var attachmsg = gettext("None");
	}
	else
	{
		if(sheetid == "")
		{
			var attachmsg = "<a href=\"../attachment/" + attacheduuid + "\">" + gettext("Download") + "</a>";
		}
		else
		{
			var attachmsg = "<a href=\"../../attachment/" + attacheduuid + "\">" + gettext("Download") + "</a>";
		}
	}
	var item =
		"<li class=\"jquery-ui-sortable-item\">" +
		"	<div class=\"sortable-handle\">" +
		"		<input type=\"image\" alt=\"Remove\" src=\"" + staticurl + "manager/img/cancel.png\" />" +
		"	</div>" +
		"	<table class=\"properties\">" +
		"		<tr>" +
		"			<td style=\"white-space: nowrap;\">" + gettext("Question:") + "</td>" +
		"			<td style=\"width: 100%;\">" + question + "</td>" +
		"		</tr>" +
		"		<tr>" +
		"			<td style=\"white-space: nowrap;\">" + gettext("Format:") + "</td>" +
		"			<td>" + format_text + "</td>" +
		"		</tr>" +
		"		<tr>" +
		"			<td style=\"white-space: nowrap;\">" + propertyname + "</td>" +
		"			<td>" + property + "</td>" +
		"		</tr>" +
		"		<tr>" +
		"			<td style=\"white-space: nowrap;\">" + gettext("Attachment:") + "</td>" +
		"			<td>" + attachmsg + "</td>" +
		"		</tr>" +
		"	</table>" +
		"	<input type=\"hidden\" class=\"question_id\" value=\"" + id + "\" />" +
		"	<input type=\"hidden\" class=\"question\" value=\"" + question + "\" />" +
		"	<input type=\"hidden\" class=\"format\" value=\"" + format + "\" />" +
		"	<input type=\"hidden\" class=\"property\" value=\"" + property + "\" />" +
		"	<input type=\"hidden\" class=\"attachment\" value=\"" + attacheduuid + "\" />" +
		"</li>";
	return item;
}

function add_question()
{
	var id = $(this).find("id").text();
	var question = $(this).find("question").html();
	var format = $(this).find("format").text();
	var property = $(this).find("property").text();
	var attachment = $(this).find("attachment").text();
	var item = get_item_tag(id, question, format, property, attachment);
	$("ul#itemlist").append(item);
	$("ul#itemlist li .sortable-handle input").click(function() {
		$target = $(this).closest("li");
		$target.hide("500", function(){$target.remove();});
		$(window).on("beforeunload", function(){
			return gettext("Modified datas are destroyed if you move.");
		});
		return false;
	});
}

function get_sheet(xml, status)
{
	if(status != "success")
		return;
	$("#title").val($(xml).find("title").text());
	$("#title").css({"color": ""});
	$(xml).find("item").each(add_question);
}

function process_message(xml, status, senddata)
{
	if(status != "success")
		return;
	var status = $(xml).find("status").text();
	var command = $(xml).find("command").text();
	var message = $(xml).find("message").text();
	if(status == "success")
	{
		$(window).off("beforeunload");
		if(command == "jump")
		{
			location.href = message;
			return;
		}
		show_notification_success(message, 10000);
	}
	else if(status == "error")
	{
		if(command == "auth")
			submit_array(message, senddata);
		show_notification_error(message, 10000);
	}
}

function append_field(question, format, property, attacheduuid)
{
	var item = get_item_tag(0, question, format, property, attacheduuid);
	$("#maxcharsrow").css({"display": "none"});
	$("#maxvaluerow").css({"display": "table-row"});
	$("#optionsrow").css({"display": "none"});
	$("ul#itemlist").append(item);
	$("ul#itemlist li:last").hide().fadeIn(500);
	$("ul#itemlist li:last .sortable-handle input").click(function() {
		$target = $(this).closest("li");
		$target.hide("300", function(){$target.remove();});
		return false;
	});
	$("#question").val("");
	$("#format").val(1);
	$("#maxchars").val(1000);
	$("#maxvalue").val(5);
	$("#options").val("");
	$("#attachpdf").removeAttr("checked");
	$("#pdffile").replaceWith($("#pdffile").val("").clone(true));
	$("#pdffile").attr("disabled", "disabled");

	$(window).on("beforeunload", function(){
		return gettext("Modified datas are destroyed if you move.");
	});
}

$(function() {
	$(".jquery-ui-sortable").sortable( {
		items: ".jquery-ui-sortable-item",
		handle: ".sortable-handle",
		opacity: 0.75,
		placeholder: "ui-state-highlight",
		start: function(e, ui){
			ui.placeholder.height(ui.item.height());
			ui.placeholder.width(ui.item.width());
		},
		change: function(e, ui){
			$(window).on("beforeunload", function(){
				return gettext("Modified datas are destroyed if you move.");
			});
		}
	})

	$("#maxchars").spinner({min: 1, max: 4000, numberFormat: "C"});
	$("#maxvalue").spinner({min: 2, max: 10, numberFormat: "C"});

	$("input.hint").css({"color": "#999"});
	hintinputcolor = $("input.hint").css("color")
	
	$("input.hint").focus(function(){
		if($(this).css("color") == hintinputcolor)
		{
			$(this).val("");
			$(this).css({"color": ""});
		}
	}).blur(function() {
		if ($(this).val().length == 0)
		{
			$(this).val(this.title);
			$(this).css({"color": "#999"});
		}
	}).each(function() {
		$(this).val(this.title);
	});
	
	$("#title").change(function() {
		$(window).on("beforeunload", function(){
			return gettext("Modified datas are destroyed if you move.");
		});
	});
	
	$("#format").change(function() {
		var val = $(this).val();
		if(val == 0 || val == 4)
		{
			$("#maxcharsrow").css({"display": "table-row"});
			$("#maxvaluerow").css({"display": "none"});
			$("#optionsrow").css({"display": "none"});
		}
		else if(val == 1)
		{
			$("#maxcharsrow").css({"display": "none"});
			$("#maxvaluerow").css({"display": "table-row"});
			$("#optionsrow").css({"display": "none"});
		}
		else if(val == 2 || val == 3)
		{
			$("#maxcharsrow").css({"display": "none"});
			$("#maxvaluerow").css({"display": "none"});
			$("#optionsrow").css({"display": "table-row"});
		}
	});
	
	$("#addbtn").click(function() {
		var question = $("<pre/>").text($("#question").val()).html().replace(/\n/g, "<br/>");
		if(question == "")
		{
			show_notification_error(gettext("Please fill the question field."), 8000);
			return;
		}
		var format = $("#format").val();
		if(format == 0)
		{
			var property = $("#maxchars").val();
			if(!(property >= 1 && property <= 4000))
			{
				show_notification_error(gettext("Please set the maximum characters to 4000 or less number."), 8000);
				return;
			}
		}
		else if(format == 1)
		{
			var property = $("#maxvalue").val();
			if(!(property >= 1 && property <= 4000))
			{
				show_notification_error(gettext("Please set the maximum value to 10 or less number."), 8000);
				return;
			}
		}
		else if(format == 2)
		{
			var property = $("#options").val();
			if(property == "" || $("#options").css("color") == hintinputcolor)
			{
				show_notification_error(gettext("Please fill the choices field."), 8000);
				return;
			}
		}
		else if(format == 3)
		{
			var property = $("#options").val();
			if(property == "" || $("#options").css("color") == hintinputcolor)
			{
				show_notification_error(gettext("Please fill the choices field."), 8000);
				return;
			}
		}
		else if(format == 4)
		{
			var property = $("#maxchars").val();
			if(!(property >= 1 && property <= 4000))
			{
				show_notification_error(gettext("Please set the maximum characters to 4000 or less number."), 8000);
				return;
			}
		}
		
		if($("#attachpdf")[0].checked)
		{
			if(sheetid == "")
				var actionpath = "../attachment/+add";
			else
				var actionpath = "../../attachment/+add";
			data = {"csrfmiddlewaretoken": $.cookie("csrftoken")};
			var uploaddata = new FormData($("#uploadform")[0]);
			
			var anmobj = proccess_start($(".boxbutton .process-container"));
			attach_completion = function(xml, status)
			{
				if(status != "success")
				{
					show_notification_error(gettext("Failed to upload PDF."), 8000);
					proccess_stop(anmobj);
					return;
				}
				if($(xml).find("status").text() == "success")
				{
					var attacheduuid = $(xml).find("message").text();
					append_field(question, format, property, attacheduuid);
				}
				else
				{
					show_notification_error($(xml).find("message").text(), 8000);
				}
				proccess_stop(anmobj);
			};
			
			$.ajax({url: actionpath, cache: false, type: "post", data: uploaddata, contentType: false, processData: false,
				success: attach_completion,
				error: attach_completion,
			});
		}
		else
		{
			append_field(question, format, property, "");
		}
	});
	
	$(".toolbox #back").click(function() {
		if(sheetid == "")
			location.href = "../../~" + owner;
		else
			location.href = "./list";
	});
	
	$(".toolbox #save").click(function() {
		var index = 0;
		var senddata = {};
		var title = $("#title").val();
		if(title == "" || $("#title").css("color") == hintinputcolor)
		{
			show_notification_error(gettext("Please fill the title field."), 8000);
			return;
		}
		senddata["title"] = title;
		senddata["mode"] = "update";
		senddata["csrfmiddlewaretoken"] = $.cookie("csrftoken");
		$("ul#itemlist li").map(function() {
			senddata["question_id_" + index] = $(this).children("input.question_id").val();
			senddata["question_" + index] = $(this).children("input.question").val().replace(/<br\/>/g, "\n");
			senddata["format_" + index] = $(this).children("input.format").val();
			senddata["property_" + index] = $(this).children("input.property").val();
			senddata["attachment_" + index] = $(this).children("input.attachment").val();
			index++;
		});
		if(index == 0)
		{
			show_notification_error(gettext("Please add at least one question."), 8000);
			return;
		}
		var anmobj = proccess_start($(".toolbox #save .process-container"));
		$.post("?result=xml", senddata, function(xml, status)
		{
			process_message(xml, status, senddata);
			proccess_stop(anmobj);
			
		}, "xml");
	});
	
	$(".toolbox #remove").click(function() {
		if(!confirm(gettext("Are you sure you want to remove this sheet?\nAll surveys related to this sheet are removed.")))
			return;
		var index = 0;
		var senddata = {};
		var anmobj = proccess_start($(".toolbox #remove .process-container"));
		senddata["mode"] = "remove";
		senddata["csrfmiddlewaretoken"] = $.cookie("csrftoken");
		$.post("?result=xml", senddata, function(xml, status)
		{
			process_message(xml, status, senddata);
			proccess_stop(anmobj);
		}, "xml");
	});
	
	$("#attachpdf").click(function() {
		if(this.checked)
		{
			$("#pdffile").removeAttr("disabled");
		}
		else
		{
			$("#pdffile").attr("disabled", "disabled");
		}
	});
	
	if(sheetid != "")
	{
		$.ajax({url: "./+xml", cache: false, type: "get", dataType: "html", timeout: 10000, success: get_sheet});
	}
});
