function get_item_tag(question, format, property, attacheduuid)
{
	if(format == 0)
	{
		format_text = gettext("Text");
		propertyname = gettext("Maximum characters:");
	}
	else if(format == 1)
	{
		format_text = gettext("Ranking");
		propertyname = gettext("Maximum value:");
	}
	else if(format == 2)
	{
		format_text = gettext("Choices (single selection)");
		propertyname = gettext("Choices:");
	}
	else if(format == 3)
	{
		format_text = gettext("Choices (multiple selection)");
		propertyname = gettext("Choices:");
	}
	else if(format == 4)
	{
		format_text = gettext("Stream");
		propertyname = gettext("Maximum characters:");
	}
	if(attacheduuid == "")
	{
		var attachmsg = gettext("None");
	}
	else
	{
		var attachmsg = "<a href=\"../attachment/" + attacheduuid + "\">" + gettext("Download") + "</a>";
	}
	var item =
		"<li class=\"jquery-ui-sortable-item\">" +
		"	<table class=\"properties\">" +
		"		<tr>" +
		"			<td style=\"white-space: nowrap;\">" + gettext("Question:") + "</td>" +
		"			<td style=\"width: 100%;\">" + question + "</td>" +
		"		</tr>" +
		"		<tr>" +
		"			<td style=\"white-space: nowrap;\">" + gettext("Format:") + "</td>" +
		"			<td>" + format_text + "</td>" +
		"		</tr>" +
		"		<tr>" +
		"			<td style=\"white-space: nowrap;\">" + propertyname + "</td>" +
		"			<td>" + property + "</td>" +
		"		</tr>" +
		"		<tr>" +
		"			<td style=\"white-space: nowrap;\">" + gettext("Attachment:") + "</td>" +
		"			<td>" + attachmsg + "</td>" +
		"		</tr>" +
		"	</table>" +
		"</li>";
	return item;
}

function add_question()
{
	var question = $(this).find("question").html();
	var format = $(this).find("format").text();
	var property = $(this).find("property").text();
	var attachment = $(this).find("attachment").text();
	var item = get_item_tag(question, format, property, attachment);
	$("ul#itemlist").append(item);
	$("ul#itemlist li .sortable-handle input").click(function() {
		$target = $(this).closest("li");
		$target.hide("500", function(){$target.remove();});
		return false;
	});
}

function get_sheet(xml, status)
{
	$("ul#itemlist li").remove();
	if(status != "success")
	{
		return;
	}
	$(xml).find("item").each(add_question);
}

function get_survey(xml, status)
{
	if(status != "success")
		return;
	$("#title").val($(xml).find("title").text());
	$("#title").css({"color": ""});
}

function view_sheet()
{
	$.ajax({url: "../../sheet/" + sheetid + "/+xml", cache: false, type: "get", dataType: "html", timeout: 10000, success: get_sheet, error: get_sheet});
}

function process_message(xml, status, senddata)
{
	if(status != "success")
		return;
	var status = $(xml).find("status").text();
	var command = $(xml).find("command").text();
	var message = $(xml).find("message").text();
	if(status == "success")
	{
		if(command == "jump")
		{
			location.href = message;
			return;
		}
		show_notification_success(message, 10000);
	}
	else if(status == "error")
	{
		if(command == "auth")
			submit_array(message, senddata);
		show_notification_error(message, 10000);
	}
}

function add_result()
{
	var path = $(this).find("path").text();
	var title = $(this).find("title").text();
	var item =
		"<li class=\"search-result-item\">" +
		"	<p class=\"sheet-id\">" + path + "</p>" +
		"	<p>" + title + "</p>" +
		"</li>";
	$("ul#sheet-search-res").append(item);
}

$(function()
{
	$("input.hint").css({"color": "#999"});
	hintinputcolor = $("input.hint").css("color")
	
	$("input.hint").focus(function(){
		if($(this).css("color") == hintinputcolor)
		{
			$(this).val("");
			$(this).css({"color": ""});
		}
	}).blur(function() {
		if ($(this).val().length == 0)
		{
			$(this).val(this.title);
			$(this).css({"color": "#999"});
		}
	}).each(function() {
		$(this).val(this.title);
	});
	
	$("#title").change(function() {
		$(window).on("beforeunload", function(){
			return gettext("Modified datas are destroyed if you move.");
		});
	});
	
	$(".toolbox #save").click(function() {
		var index = 0;
		var senddata = {};
		var title = $("#title").val();
		if(title == "" || $("#title").css("color") == hintinputcolor)
		{
			show_notification_error(gettext("Please fill the title field."), 8000);
			return;
		}
		senddata["title"] = title;
		senddata["mode"] = "update";
		senddata["csrfmiddlewaretoken"] = $.cookie("csrftoken");
		var anmobj = proccess_start($(".toolbox #save .process-container"));
		$.post("?result=xml", senddata, function(xml, status)
		{
			$(window).off("beforeunload");
			process_message(xml, status, senddata);
			proccess_stop(anmobj);
			
		}, "xml");
	});
	
	$(".toolbox #remove").click(function() {
		if(!confirm(gettext("Are you sure you want to remove this survey?")))
			return;
		var index = 0;
		var senddata = {};
		var anmobj = proccess_start($(".toolbox #remove .process-container"));
		senddata["mode"] = "remove";
		senddata["csrfmiddlewaretoken"] = $.cookie("csrftoken");
		$.post("?result=xml", senddata, function(xml, status)
		{
			$(window).off("beforeunload");
			process_message(xml, status, senddata);
			proccess_stop(anmobj);
		}, "xml");
	});
	
	$("#sheet-search").keypress(function(event) {
		if(event.which === 13){
			search_sheet();
		}
	});
	
	$("#select-sheet-dialog").dialog({
		autoOpen: false,
		width: 400,
		height: 300,
		minWidth: 300,
	});
	
	$("#show-dialog").click(function() {
		$("#select-sheet-dialog").dialog( "open" );
	});
	
	if(surveyid != "")
	{
		$.ajax({url: "./+xml", cache: false, type: "get", dataType: "xml", timeout: 10000, success: get_survey, error: get_survey});
	}
	
	view_sheet();
});
