from django.conf.urls import patterns, include, url
from django.core.urlresolvers import reverse

urlpatterns = patterns("manager.views",
	url(r"^$", "top.top_view", name="manager"),
	url(r"^\+login$", "auth.auth_view"),
	url(r"^\+logout$", "auth.logout_view"),
	url(r"^(?P<callback>.+)/\+login$", "auth.auth_view"),
	url(r"^\+register$", "register.register_view"),
	url(r"^~(?P<owner>\w+)$", "userpage.userpage_view"),
	url(r"^~(?P<owner>\w+)/sheet/\+xml$", "sheetlist.xml_view"),
	url(r"^~(?P<owner>\w+)/sheet/\+add$", "sheetedit.add_view"),
	url(r"^~(?P<owner>\w+)/sheet/(?P<sheet_id>\d+)/list$", "surveylist.surveylist_view"),
	url(r"^~(?P<owner>\w+)/sheet/(?P<sheet_id>\d+)/list/\+xml$", "surveylist.xml_view"),
	url(r"^~(?P<owner>\w+)/sheet/(?P<sheet_id>\d+)/\+edit$", "sheetedit.edit_view"),
	url(r"^~(?P<owner>\w+)/sheet/(?P<sheet_id>\d+)/\+xml$", "sheet.xml_view"),
	url(r"^~(?P<owner>\w+)/survey/\+add/(?P<sheet_id>\d+)$", "surveyedit.add_view"),
	url(r"^~(?P<owner>\w+)/survey/(?P<survey_id>\d+)$", "survey.survey_view"),
	url(r"^~(?P<owner>\w+)/survey/(?P<survey_id>\d+)/\+csv$", "survey.download_csv"),
	url(r"^~(?P<owner>\w+)/survey/(?P<survey_id>\d+)/\+edit$", "surveyedit.edit_view"),
	url(r"^~(?P<owner>\w+)/survey/(?P<survey_id>\d+)/\+xml$", "survey.xml_view"),
	url(r"^~(?P<owner>\w+)/survey/(?P<survey_id>\d+)/\+result$", "survey.resultxml_view"),
	url(r"^~(?P<owner>\w+)/attachment/\+add$", "attachment.upload"),
	url(r"^~(?P<owner>\w+)/attachment/(?P<uuid>\S+)/\+png$", "attachment.pdf_view"),
	url(r"^~(?P<owner>\w+)/attachment/(?P<uuid>\S+)/\+xml$", "attachment.pdf_xml"),
	url(r"^~(?P<owner>\w+)/attachment/(?P<uuid>\S+)$", "attachment.download_attachment"),
)
