from django.db import connection, transaction

def create_survey_table(survey):
	cursor = connection.cursor()
	cols = "id integer AUTO_INCREMENT NOT NULL PRIMARY KEY"
	sheet = survey.sheet
	questions = sheet.question_set.all()
	for q in questions:
		cols += ", "
		if q.ans_format == 0:
			cols += "q_%d varchar(%s) NOT NULL" % (q.id, q.ans_property)
		elif q.ans_format == 1:
			cols += "q_%d integer NOT NULL" % q.id
		elif q.ans_format == 2:
			cols += "q_%d integer NOT NULL" % q.id
		elif q.ans_format == 3:
			cols += "q_%d varchar(400) NOT NULL" % q.id
		elif q.ans_format == 4:
			cols += "q_%d varchar(%s) NOT NULL" % (q.id, q.ans_property)
	cursor.execute("CREATE TABLE survey_%d (%s)" % (survey.id, cols))

def drop_survey_table(survey):
	cursor = connection.cursor()
	cursor.execute("DROP TABLE survey_%d" % survey.id)

def add_column(survey, q):
	cursor = connection.cursor()
	if q.ans_format == 0:
		fmt = "varchar(%s) NOT NULL DEFAULT ''" % q.ans_property
	elif q.ans_format == 1:
		fmt = "integer NOT NULL DEFAULT -1"
	elif q.ans_format == 2:
		fmt = "integer NOT NULL DEFAULT -1"
	elif q.ans_format == 3:
		fmt = "varchar(400) NOT NULL DEFAULT '-1'"
	elif q.ans_format == 4:
		fmt = "varchar(%s) NOT NULL DEFAULT ''" % q.ans_property
	cursor.execute("ALTER TABLE survey_%d ADD q_%d %s" % (survey.id, q.id, fmt))

def drop_column(survey, q):
	cursor = connection.cursor()
	cursor.execute("ALTER TABLE survey_%d DROP q_%d" % (survey.id, q.id))

def select_from_survey_table(survey, offset):
	cursor = connection.cursor()
	query = "SELECT * FROM survey_%d LIMIT %d,18446744073709551615;" % (survey.id, offset)
	cursor.execute(query)
	desc = cursor.description
	return [[{"id": int(desc[i][0].split("_")[1]), "data": data} for i, data in enumerate(row) if "_" in desc[i][0]] for row in cursor.fetchall()]
