from django.contrib.auth import authenticate, login, logout
from django.shortcuts import render_to_response
from django.utils.translation import ugettext as _
from django.core.context_processors import csrf
from django.http import HttpResponseRedirect
from django.template import RequestContext
from django.core.urlresolvers import reverse
import manager, os

def auth_view(request, callback = ""):
	if request.user.is_authenticated() and callback == "":
		return HttpResponseRedirect("%s~%s" % (reverse("manager"), request.user.username))
	errmsg = ""
	message = ""
	passdata_tags = ""
	if request.method == "POST" and "user" in request.POST:
		username = request.POST["user"]
		password = request.POST["pass"]
		user = authenticate(username=username, password=password)
		if user is not None:
			if user.is_active:
				login(request, user)
				if callback == "":
					return HttpResponseRedirect("%s~%s" % (reverse("manager"), username))
				else:
					realname = user.get_full_name()
					callback = "%s%s" % (reverse("manager"), callback)
					c = {"username": username, "realname": realname, "datas": request.POST, "callback": callback, "manager_path": reverse("manager")}
					c.update(csrf(request))
					return render_to_response("manager/auth_continue.html", c, context_instance=RequestContext(request))
			else:
				errmsg = _("Invalid account")
		else:
			errmsg = _("Failed to authenticate")
	
	if callback != "":
		message = _("Authentication is required to continue.")
	c = {"datas": request.POST, "errmsg": errmsg, "message": message, "manager_path": reverse("manager")}
	c.update(csrf(request))
	return render_to_response("manager/auth.html", c, context_instance=RequestContext(request))

def logout_view(request):
	logout(request)
	c = {"manager_path": reverse("manager")}
	return render_to_response("manager/logout.html", c, context_instance=RequestContext(request))
