from django.contrib.auth.models import User
from manager.models import Sheet
from django.shortcuts import render_to_response
from django.http import Http404
from django.template import RequestContext
from django.core.urlresolvers import reverse
from manager.utils.exceptions import Http403

def xml_view(request, owner="", sheet_id=""):
	if request.user.is_authenticated():
		user = request.user
		username = user.username
		realname = user.get_full_name()
		if username == owner:
			permlevel = 0
		elif user.is_staff:
			permlevel = 0
		else:
			permlevel = 1
	else:
		permlevel = 2

	try:
		ownerdata = User.objects.get(username=owner)
	except User.DoesNotExist:
		raise Http404
	
	try:
		sheet = Sheet.objects.filter(owner=owner).get(id=sheet_id)
	except Sheet.DoesNotExist:
		raise Http404

	# Check permission
	if sheet.permission < permlevel:
		raise Http403

	questions = sheet.question_set.order_by("order")
	c = {"title": sheet.title, "questions": questions}
	return render_to_response("manager/sheet.xml", c, mimetype="application/xml")

