from django.contrib.auth.models import User
from django.shortcuts import render_to_response
from django.utils.translation import ugettext as _
from manager.models import Sheet
from django.http import Http404
from django.template import RequestContext
from django.core.urlresolvers import reverse
from manager.utils.exceptions import Http403

def xml_view(request, owner=""):
	try:
		ownerdata = User.objects.get(username=owner)
	except User.DoesNotExist:
		raise Http404
	
	if request.user.is_authenticated():
		user = request.user
		if user.username == owner:
			permlevel = 0
		elif user.is_staff:
			permlevel = 0
		else:
			permlevel = 1
	else:
		permlevel = 3

	start = request.GET["start"] if "start" in request.GET else "0"
	start = int(start) if start.isdigit() else 0
	length = request.GET["length"] if "length" in request.GET else "10"
	length = int(length) if length.isdigit() else 10
	if length > 30:
		length = 30
	# owner = owner, permission >= permlevel
	sheets = Sheet.objects.filter(owner=owner).filter(permission__gte=permlevel).order_by("-mod_date")[start:start+length]
	
	c = {"sheets": sheets}
	return render_to_response("manager/sheetlist.xml", c, mimetype="application/xml")

