from django.contrib.auth.models import User
from django.shortcuts import render_to_response
from django.utils.translation import ugettext as _
from django.http import Http404
from django.template import RequestContext
from django.core.urlresolvers import reverse

def userpage_view(request, owner=""):
	username = ""
	realname = ""
	status = ""
	message = ""
	
	if request.user.is_authenticated():
		username = request.user.username
		realname = request.user.get_full_name()
	try:
		ownerdata = User.objects.get(username=owner)
	except User.DoesNotExist:
		raise Http404

	realownername = ownerdata.get_full_name()
	if realownername == "":
		realownername = owner
	
	if request.user.is_authenticated():
		user = request.user
		username = user.username
		realname = user.get_full_name()
		if username == owner:
			permlevel = 0
		elif user.is_staff:
			permlevel = 0
		else:
			permlevel = 3
	else:
		permlevel = 3
	
	if "removed" in request.session and request.session.pop("removed"):
		status = "success"
		message = _("Successfully removed.")
	c = {"username": username, "realname": realname, "realownername": realownername, "owner": owner, "status": status, "message": message, "manager_path": reverse("manager"), "permlevel": permlevel}
	return render_to_response("manager/userpage.html", c, context_instance=RequestContext(request))
