import qrencode
from django.core.urlresolvers import reverse
from django.http import HttpResponse
from manager.models import Survey
from unaju.settings import URL_BASE
from django.http import Http404

def view(request, survey_id):
	try:
		survey = Survey.objects.get(id=survey_id)
	except Survey.DoesNotExist:
		raise Http404
		
	sizestr = request.GET["size"] if "size" in request.GET else ""
	size = int(sizestr) if sizestr.isdigit() else 0
	if size > 400:
		size = 400
	qr = qrencode.encode_scaled("%s%s" % (URL_BASE, reverse("poll", args=[survey_id])), size)
	response = HttpResponse(mimetype="image/png")
	qr[2].save(response, "PNG")
	return response
